﻿'
'  FLYFISH TECHNOLOGIES Ltd.
'  http://www.flyfish-tech.com
'  
'  hiDBLUE API usage example
'  
'  
'  
'  This code is in the Public Domain. Use it at your own risk.
'

Imports System.Text

Public Class Form1

    Private WithEvents API As New hiDBLUE.API
    Private strOldRecipient As String = ""
    Private strOldContent As String = ""
    Private blnTargetTextBox1 As Boolean = True
    Private blnPreventLoopback As Boolean = False

    Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        API.Init()
        System.Windows.Forms.Control.CheckForIllegalCrossThreadCalls = False
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        API.Dispose()
    End Sub


    Private Sub TextBox1_TextChanged(sender As System.Object, e As System.EventArgs) Handles TextBox1.TextChanged
        If blnPreventLoopback = False Then
            If strOldRecipient.Length > TextBox1.Text.Length Then
                SendPacket(CByte(&H12), True)       'Backspace'
            Else
                SendPacket(GetLastCharacter(TextBox1.Text), False)
            End If
        End If
        strOldRecipient = TextBox1.Text
        blnPreventLoopback = False
    End Sub

    Private Sub TextBox1_GotFocus(sender As Object, e As System.EventArgs) Handles TextBox1.GotFocus
        If blnPreventLoopback = False Then
            SendPacket(CByte(&H1), True)        ' focus to Recipient
        End If
        blnPreventLoopback = False
    End Sub

    Private Sub TextBox2_TextChanged(sender As System.Object, e As System.EventArgs) Handles TextBox2.TextChanged
        If blnPreventLoopback = False Then
            If strOldContent.Length > TextBox2.Text.Length Then
                SendPacket(CByte(&H12), True)       'Backspace'
            Else
                SendPacket(GetLastCharacter(TextBox2.Text), False)
            End If
        End If
        strOldContent = TextBox2.Text
        blnPreventLoopback = False
    End Sub

    Private Sub TextBox2_GotFocus(sender As Object, e As System.EventArgs) Handles TextBox2.GotFocus
        If blnPreventLoopback = False Then
            SendPacket(CByte(&H2), True)        ' focus to Content
        End If
        blnPreventLoopback = False
    End Sub


    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        SendPacket(CByte(&HF0), True)        'SEND'
        MsgBox("The SMS has been sent")
        TextBox1.Text = ""
        TextBox2.Text = ""
    End Sub


    Private Function GetLastCharacter(strString As String) As Byte
        Dim encUTF8 As Encoding = Encoding.UTF8
        Dim bytString As Byte() = encUTF8.GetBytes(strString)
        Return bytString(bytString.Length - 1)
    End Function


    ' The Packet data is delivered to function ProcessReceivedAPIData, implemented in Android Demo application
    Private Sub SendPacket(bytChar As Byte, isControl As Boolean)
        Dim bytPacket() As Byte

        ReDim bytPacket(1)              ' Packet contains 2 bytes. Max size is 8 bytes.

        If isControl = True Then
            bytPacket(0) = CByte(1)     ' THIS IS ARBITRARY VALUE, USED EXCLUSIVELY HERE AND IN ANDROID DEMO APPLICATION
        Else
            bytPacket(0) = CByte(2)     ' THIS IS ARBITRARY VALUE, USED EXCLUSIVELY HERE AND IN ANDROID DEMO APPLICATION
        End If
        bytPacket(1) = bytChar

        API.Send(bytPacket)
    End Sub


    ' The Packet data is received from function SendPacketToPC, implemented in Android Demo application
    Public Sub HandleReceivedPacket(ByVal bytPacket() As Byte) Handles API.PacketReceived
        Dim bytChar(0) As Byte

        If bytPacket(0) = CByte(1) Then     ' control, THIS IS ARBITRARY VALUE, USED EXCLUSIVELY HERE AND IN ANDROID DEMO APPLICATION
            Select Case bytPacket(1)
                Case CByte(&H1)             ' focus on Recipient textbox
                    blnTargetTextBox1 = True
                    TextBox1.Focus()
                Case CByte(&H2)             ' focus on content textbox
                    blnTargetTextBox1 = False
                    TextBox2.Focus()
                Case CByte(&H12)            ' backspace chatacter
                    If blnTargetTextBox1 = True Then
                        If TextBox1.Text <> "" Then
                            blnPreventLoopback = True
                            TextBox1.Text = TextBox1.Text.Substring(0, TextBox1.Text.Length - 1)
                        End If
                    Else
                        If TextBox2.Text <> "" Then
                            blnPreventLoopback = True
                            TextBox2.Text = TextBox2.Text.Substring(0, TextBox2.Text.Length - 1)
                        End If
                    End If
                Case CByte(&HF0)
                    MsgBox("The SMS has been sent")
                    TextBox1.Text = ""
                    TextBox2.Text = ""
            End Select
        Else                                ' data, THIS IS ARBITRARY VALUE, USED EXCLUSIVELY HERE AND IN ANDROID DEMO APPLICATION
            bytChar(0) = bytPacket(1)
            blnPreventLoopback = True
            If blnTargetTextBox1 = True Then
                TextBox1.Text = TextBox1.Text + Encoding.UTF8.GetString(bytChar)
            Else
                TextBox2.Text = TextBox2.Text + Encoding.UTF8.GetString(bytChar)
            End If
        End If
    End Sub


End Class
